#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);    

  use DBI;
  use strict;


# Get the form input
  my %FORM = wwwthreads::get_input;


# Assign the variables
  my $Username = $FORM{'Username'};
  my $Subject = $FORM{'Subject'};
  my $Body = $FORM{'Body'};
  my $Board = $FORM{'Board'};
  my $IP = $FORM{'IP'};
  my $Parent = $FORM{'Parent'};
  my $Main = $FORM{'Main'};
  my $page = $FORM{'page'};
  my $view = $FORM{'view'};
  my $what = $FORM{'what'};
  my $oldnumber = $FORM{'oldnumber'};
  my $mode = $FORM{'mode'};
  my $sb = $FORM{'sb'};
  my $query = '';
  my $sth = '';
  my $Signature = '';

# Connect to the database
  wwwthreads::db_connect;


# Grab the next available number for this post
  $query = qq!
    SELECT _seq FROM $Board
  !; 
  $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my ($Number) = $sth -> fetchrow_array;


# If this isn't a reply post then the main variable gets set to itself
  if(!$Main) {

    $Main = $Number;

  }


# Get the current time
  my $date = wwwthreads::get_date;


# As long as the User didn't post Anonymously we need to update some stuff
  if ( $Username ne "Anonymous" ) {

    my $Username_q = $dbh -> quote($Username);
    
  # Grab their total posts and their signature
    $query = qq!
      SELECT Totalposts,Signature
      FROM Users
      WHERE Username = $Username_q
    !;
    $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

    my ($Total,$Signature) = $sth -> fetchrow_array;

    $Total++;


  # Update their total posts
    $query = qq!
      UPDATE Users
      SET Totalposts = $Total
      WHERE Username = $Username_q
    !;
    my $rc = $dbh -> do($query) or die "Can't execute query: $query. Reason: $DBI::errstr";
 
  }


# Combine the body and signature and then quote it properly
  $Body = "$Body<br><br>$Signature";
  $Body = $dbh -> quote($Body);
  my $Subject_q = $dbh -> quote($Subject);
  my $Board_q = $dbh -> quote($Board);
  my $Username_q = $dbh -> quote($Username);

# If this isn't a reply post then $Parent gets set to 0
  if (!$Parent) { $Parent = 0; }


# Insert the post into the database
  $IP = $dbh -> quote($IP);
  $query = qq!
    INSERT INTO $Board (Number,Parent,Main,Posted,Username,IP,Subject,Body)
    VALUES ($Number,$Parent,$Main,$date,$Username_q,$IP,$Subject_q,$Body)
  !;
  my $rc = $dbh -> do($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# Grab the current total posts for this board 
  $query =qq!
    SELECT Total
    FROM Boards
    WHERE Keyword=$Board_q
  !;
  $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my ($Total) = $sth -> fetchrow_array;
  $Total++;


# Update total posts and last post for this board
  $query = qq!
    UPDATE Boards
    SET Total=$Total,Last=$date
    WHERE Keyword = $Board_q
  !;

  $rc = $dbh -> do($query) or die "Can't execute query: $query. Reason: $DBI::errstr";

  if($what eq "showpost") {

    wwwthreads::send_header("Your post has been entered","<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;url=$wwwthreads::config{'cgiurl'}/showpost.pl?Board=$Board&Number=$oldnumber&page=$page&view=$view&mode=$mode&sb=$sb\">");

  } else {

    wwwthreads::send_header("Your post has been entered","<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;url=$wwwthreads::config{'cgiurl'}/wwwthreads.pl?action=list&Board=$Board&page=$page&view=$view&sb=$sb\">");

  }


# Now we give them a confirmation page
  wwwthreads::table_header("Your post has been entered");;
  print qq~ 
  Your post has been entered.  Thanks for contributing to our forum.  You will be returned to the forum shortly.
  ~;

# Send the footer
  $sth -> finish;
  wwwthreads::send_footer;

