#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);

  use DBI;
  use strict;


# Get the input
  my %FORM = wwwthreads::get_input();

  my $Username = $FORM{'Username'};
  my $Password = $FORM{'Password'};
  my $Verify = $FORM{'Verify'};
  my $Fakeemail = $FORM{'Fakeemail'};
  my $Email = $FORM{'Email'};
  my $Signature = $FORM{'Signature'};
  my $Homepage = $FORM{'Homepage'};
  my $Occupation = $FORM{'Occupation'};
  my $Hobbies = $FORM{'Hobbies'};
  my $Location = $FORM{'Location'};
  my $Bio = $FORM{'Bio'};
  my $Sort = $FORM{'sort_order'};
  my $Display = $FORM{'display'};
  my $View = $FORM{'view'};
  my $PostsPer = $FORM{'PostsPer'};

# If the password isn't the proper length we can't proceed  
  if((length($Password)<4) || (length($Password)>10)){

    wwwthreads::not_right("Password needs to be between 4 and 10 characters.");

  }

# If homepage is greater than 150 then we can't proceed
  if ( length($Homepage) > 150 ) {

    wwwthreads::not_right("The Homepage entry is too long"); 

  }


# If Occupation is greater than 150 then we can't proceed
  if ( length($Occupation) > 150 ) {

    wwwthreads::not_right("The Occupation entry is too long");

  }


# If hobbies is greater than 200 then we can't proceed
  if ( length($Hobbies) > 200 ) {

    wwwthreads::not_right("The Hobbies entry is too long");

  }


# If location is greater than 200 then we can't proceed
  if ( length($Location) > 200 ) {

    wwwthreads::not_right("The Location entry is too long");

  }


# If the 2 given password do not match then we can't proceed  
  if($Password ne $Verify){

    wwwthreads::not_right("Passwords do not match");

  }

# If Posts per is less than 1 or greater than 999, can't proceed
  if( ($PostsPer < 1) || ($PostsPer > 999) ) {

    wwwthreads::not_right("Posts per page value cannot be used.");

  }


# Connect to the database
  wwwthreads::db_connect();

  my $Password_q   = $dbh -> quote($Password);
  my $Email_q      = $dbh -> quote($Email);
  my $Fakeemail_q  = $dbh -> quote($Fakeemail);
  my $Signature_q  = $dbh -> quote($Signature);
  my $Homepage_q   = $dbh -> quote($Homepage);
  my $Occupation_q = $dbh -> quote($Occupation);
  my $Hobbies_q    = $dbh -> quote($Hobbies);
  my $Location_q   = $dbh -> quote($Location);
  my $Bio_q        = $dbh -> quote($Bio);
  my $Username_q   = $dbh -> quote($Username);
  my $Display_q    = $dbh -> quote($Display);
  my $View_q       = $dbh -> quote($View);

# Update the User's profile
  my $query =qq!
    UPDATE Users
    SET Password = $Password_q,
    Email = $Email_q,
    Fakeemail = $Fakeemail_q,
    Signature = $Signature_q,
    Homepage = $Homepage_q,
    Occupation = $Occupation_q,
    Hobbies = $Hobbies_q,
    Location = $Location_q,
    Bio = $Bio_q,
    Sort = $Sort,
    Display = $Display_q,
    View = $View_q,
    PostsPer = $PostsPer
    WHERE Username = $Username_q
  !; 
  my $rc = $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# Set the cookie with their default sort and display properties
  wwwthreads::set_cookie('Sort',"$Sort",1,'Display',"$Display",1,'View',"$View",1,'PostsPer',"$PostsPer",1);

# Send them to their start page with the confirmation
  wwwthreads::start_page($Username,$Password,1,"Your profile has been modified");
