#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);

  use DBI;
  use strict;

  wwwthreads::db_connect;
  my $statement = '';
  my $sth       = '';
  my $rc        = '';

##################### The Board Table ##############################

# Create the Board Table
  $statement = qq!
CREATE TABLE Boards(
	Title Text(150),
	Description TEXT(250),
	Keyword CHAR(100),
	Moderator CHAR(30),
	Total UINT,
	Last UINT,
	HTML CHAR(10),
	Anonymous CHAR(10),
	Locked CHAR(15),
	Number UINT
)!;

  $rc = $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";


# Create a Unique Index on the Keyword
  $statement = qq!
CREATE UNIQUE INDEX keyword_ndx ON Boards (
       Keyword\n
)!;

  $rc = $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";


# Create a sequence on the Boards Table
  $statement = "CREATE SEQUENCE ON Boards STEP 1 VALUE 1";

  $rc = $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";

############################## The User Table ########################

# Create the User Table
  $statement = qq!
CREATE TABLE Users(
	Username CHAR(30),
	Password CHAR(20),
	Email CHAR(50),
	Fakeemail CHAR(50),
	Totalposts UINT,
	Laston UINT,
	Signature TEXT(100),
	Homepage CHAR(150),
	Occupation CHAR(150),
	Hobbies CHAR(200),
	Location CHAR(200),
	Bio TEXT(250),
	Status CHAR(30)
)!;

  $rc = $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";


# Create Unique User Index 
  $statement = qq!
CREATE UNIQUE INDEX username_ndx ON Users (
	Username
)!;

  $rc = $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";


# Create Status index
  $statement = qq!
CREATE INDEX status_ndx ON Users (
	Status\n
)!;

  $rc = $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";

######################## Private Message Table ##########################

# Create the Private Messages Table
  $statement = qq!
CREATE TABLE Messages(
	Username CHAR(30),
	Read CHAR(1),
	Subject CHAR(60),
	Sender CHAR(30),
	Message TEXT(250),
	When UINT,
	Number UINT
)!;

  $rc = $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";


# Create Index on Usernames
  $statement = qq!
CREATE INDEX messages_ndx ON Messages (
	Username\n
)!;

  $rc = $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";


# Create sequence on Messages
  $statement = "CREATE SEQUENCE ON Messages STEP 1 VALUE 1";

  $rc = $dbh -> do ($statement) or die "Can't execute query. Reason: $DBI::errstr";

# Disconnect
  $sth -> finish;
  $rc  -> finish;
  wwwthreads::db_disconnect();
