#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);

  use DBI;
  use strict;


# Get the form input
  my %FORM = wwwthreads::get_input();


# Get the cookie
  my %cookie = wwwthreads::get_cookie();


# Assign the variables
  my $Username = $cookie{'Username'};
  my $Board    = $FORM{'Board'};
  my $page     = $FORM{'page'};
  my $view     = $FORM{'view'};
  my $what     = $FORM{'what'};
  my $Number   = $FORM{'Number'};
  my $mode     = $FORM{'mode'};
  my $sb       = $FORM{'sb'};


# Connect to the database
  wwwthreads::db_connect();


# For security purposes we need to verify that this is user made this post or 
# if they are an admin or a moderator for this board.
  my $Username_q = $dbh -> quote($Username);
  my $query = qq!
    SELECT Status
    FROM Users
    WHERE Username = $Username_q
  !;
  my $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# Assign the retrieve data to @arr
  my ($Status) = $sth -> fetchrow_array;


# Get the post info from the database
  $query = qq!
    SELECT Username,Subject,Body
    FROM $Board
    WHERE Number = $Number
  !;
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# Assign the retrieved data to @post
  my ($Postedby,$Subject,$Body) = $sth -> fetchrow_array;


# Grab the moderator for this board
  my $Board_q = $dbh -> quote($Board);
  $query = qq!
    SELECT Moderator
    FROM Boards
    WHERE Keyword = $Board_q
  !;
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr.  Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# Assign the retreived data to @board
  my ($Moderator) = $sth -> fetchrow_array;


# Lets see if the user made this post or if the User is an admin or if
# the user is the moderator for this board.
  if ( ($Username ne $Postedby) && ($Status ne "Administrator") && ( $Username ne $Moderator) ) {

    wwwthreads::not_right("We could not verify that you made this post, that you have Administrator priviledges or that you are a moderator for this board.  Because of this, we cannot allow you to edit this post.");

  }


# Well everything checked out, doesn't look like a hacker so let's let them
# edit the post. 
  wwwthreads::send_header("Edit Post");


# Get rid of the line breaks
  $Body =~s /<br>/\n/g;


# Change " to &quot;
  $Subject =~s /"/&quot;/g;
  $Body =~s /"/&quot;/g;


# Give them the page
  wwwthreads::table_header("Edit post");;

  print qq~ 

  You may edit anything below to change this post, or you may delete it.  If
you choose to delete the post then Subject of the post will be change to
"This post has been deleted".  This is done to keep the threading format intact.

  <form method=POST action="$wwwthreads::config{'cgiurl'}/previewedit.pl">
  <input type=hidden name=Username value="$Username">
  <input type=hidden name=Board value="$Board">
  <input type=hidden name=Number value="$Number">
  <input type=hidden name="page" value="$page">
  <input type=hidden name="view" value="$view">
  <input type=hidden name="what" value="$what">
  <input type=hidden name="mode" value="$mode">

  <p>
  Subject<br>
  <input type=text name=Subject value="$Subject">
  <br><br>
  <textarea cols=80 rows=5 wrap=soft name=Body>$Body</textarea>
  <br><br>
  <input type=submit name="option" value="Change this post">

  <input type=submit name="option" value="Delete this post">
  </form>
  ~;

# send the footer
  $sth -> finish;
  wwwthreads::send_footer(); 

