#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);

  use DBI;
  use strict;


# Get the cookie
  my %cookie = wwwthreads::get_cookie;


# Assign the variables
  my $Username = $cookie{'Username'};


# Connect to the database
  wwwthreads::db_connect;
  my $query = '';
  my $sth   = '';
  my $rows  = '';

# Get the current profile for this username
  my $Username_q = $dbh -> quote($Username);
  $query = qq!
    SELECT Password,Email,Fakeemail,Signature,Homepage,Occupation,Hobbies,Location,Bio,Sort,Display,View,PostsPer
    FROM Users
    WHERE Username = $Username_q
  !;
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# Make sure we found this Username
  $rows = $sth -> rows;

  if ($rows < 1){

    &not_right("We could not find a profile for the Username '$Username'");

  }


# Assign the retrieved data
  my($Password,$Email,$Fakeemail,$Signature,$Homepage,$Occupation,$Hobbies,$Location,$Bio,$Sort,$Display,$View,$PostsPer) = $sth -> fetchrow_array;

# Find out if they already have a sort preference
  my $DS = '';
  my $AS = '';
  my $DP = '';
  my $AP = '';
  my $DD = '';
  my $AD = '';
  if($Sort == 1) { $DS = "selected"; } 
  if($Sort == 2) { $AS = "selected"; }
  if($Sort == 3) { $DP = "selected"; } 
  if($Sort == 4) { $AP = "selected"; }
  if($Sort == 5) { $DD = "selected"; }
  if($Sort == 6) { $AD = "selected"; }

# Find out if they already have a display preference
  my $flat     = '';
  my $threaded = '';
  if($Display eq "flat")     { $flat = "selected"; };
  if($Display eq "threaded") { $threaded = "selected"; }

# Find out if they have a view preference
  my $collapsed = '';
  my $expanded  = '';
  if($View eq "collapsed") { $collapsed = "selected"; }
  if($View eq "expanded")  { $expanded  = "selected"; }

# Convert returns to <br>s
  $Signature =~s /<br>/\n/g;
  $Bio =~s /<br>/\n/g;


# Change the quotes to &quot;
  $Password =~s /"/&quot;/g;
  $Email =~s /"/&quot;/g;
  $Fakeemail =~s /"/&quot;/g;
  $Signature =~s /"/&quot;/g;
  $Homepage =~s /"/&quot;/g;
  $Occupation =~s /"/&quot;/g;
  $Hobbies =~s /"/&quot;/g;
  $Location =~s /"/&quot;/g;
  $Bio =~s /"/&quot;/g;


# Ok, we found the profile, now lets put it all onto a page
  wwwthreads::send_header("Profile for $Username");

  print qq~

  <table border=0 width=100% bgcolor=$wwwthreads::config{'tddark'}>
  <tr><td>
  <font size = +2><b>
  Edit profile for $Username
  </b></font>
  </td></tr>
  </table>

  <p>
  You can edit any of the information below.
  </p><p>
  <form method = POST action = "$wwwthreads::config{'cgiurl'}/changeprofile.pl">
  <input type = hidden name = Username value ="$Username">
  Password (between 4 and 10 characters)<br>
  <input type = password name=Password value = "$Password" maxlength=10>
  <br><br>
  Verify Password<br>
  <input type = password name = Verify value = "$Password" maxlength=10>
  <br><br>
  Email Address (Not available to other users)<br>
  <input type = text name = Email value = "$Email">
  <br><br>
  Fake Email (shown on your profile page to other users)<br>
  <input type = text name = Fakeemail value = "$Fakeemail">
  <br><br>
  Signature (up to 100 characters)<br>
  <textarea name=Signature cols=50 rows=3>$Signature</textarea>
  <br><br>
  Homepage (up to 150 characters)<br>
  http://<input type=text name=Homepage value = "$Homepage">
  <br><br>
  Occupation<br>
  <input type=text name=Occupation value = "$Occupation">
  <br><br>
  Hobbies (up to 200 characters)<br>
  <input type=text name=Hobbies value = "$Hobbies">
  <br><br>
  Geographic Location (State, Country, etc.)<br>
  <input type=text name=Location value = "$Location">
  <br><br>
  Bio (up to 250 characters)<br>
  <textarea name=Bio cols=80 rows=5>$Bio</textarea>
  <br><br>
  Default sort order<br>
  <select name = "sort_order">
    <option value = 1 $DS>Descending Subject</option>
    <option value = 2 $AS>Ascending Subject</option>
    <option value = 3 $DP>Descending Poster</option>
    <option value = 4 $AP>Ascending Poster</option>
    <option value = 5 $DD>Descending Date</option>
    <option value = 6 $AD>Ascending Date</option>
  </select><br><br>
  Default display mode<br>
  <select name = "display">
    <option value = "threaded" $threaded>Threaded Mode</option>
    <option value = "flat" $flat>Flat Mode</option>
  </select><br><br>
  Default view<br>
  <select name = "view">
    <option value = "collapsed" $collapsed>Collapsed Threads</option>
    <option value = "expanded"  $expanded>Expanded Threads</option>
  </select><br><br>
  Total parent posts to show per page: (default is $wwwthreads::config{'postsperpage'})<br>
  <input type=text name=PostsPer maxlength = 3 size = 3 value = $PostsPer><br><br>

  
  <input type=submit value=submit>
  </FORM>
~;


# send the footer
  $sth -> finish;
  wwwthreads::send_footer();
