#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);
  use DBI;
  use strict;


# Connect to the database 
  wwwthreads::db_connect;


# Get the input
  my %FORM = wwwthreads::get_input;


# Grab the cookie
  my %cookie = wwwthreads::get_cookie;


# Assign the variables
  my $Username = $cookie{'Username'};
  my $Password = $cookie{'Password'};
  my $Board = $FORM{'Board'};
  my $what = $FORM{'what'};
  my $page = $FORM{'page'};
  my $view = $FORM{'view'};
  my $sb = $FORM{'sb'};


  my $Board_q = $dbh -> quote($Board);

# Get the board info
  my $query =qq!
    SELECT HTML,Anonymous,Locked
    FROM Boards
    WHERE Keyword = $Board_q
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# Assign the retreived values to @arr
  my ($HTML,$Anonymous,$Locked) = $sth -> fetchrow_array;


# Give them a page 
  wwwthreads::send_header("Make a New Post");

  wwwthreads::table_header("Make a New Post");

  print "Fill out the form below to post a message on the board.";


  if($HTML eq "Off"){

  # HTML is disabled, so we better let them know
    print " HTML is disabled for this board so you may not use HTML in your posts.";


  } else {

  # HTML is enabled, so let them know
    print " HTML is enabled for this board so you may use HTML in your posts.";

  }


  
  if($Anonymous eq "On"){

  # Anonymous is enabled, so let them know
    print" Anonymous postings are allowed, so if you do not have a Username just put Anonymous in the Username field and leave the password blank.";

  } else {

  # Anonymous is disabled, so let them know
    print" Anonymous postings are not allowed, so you will need to register a Username before you can post.";

  }
  
 
# The board is locked, so let them know
  if($Locked ne "Open"){

    print" This board is read only, so you must be an administrator to post on it.";

  }

  print qq~
  </p><p>
  <form method= POST action = "$wwwthreads::config{'cgiurl'}/previewpost.pl">
  <input type=hidden name=Board value="$Board">
  <input type=hidden name=what value="$what">
  <input type=hidden name=page value="$page">
  <input type=hidden name=view value="$view">
  <input type=hidden name=sb value="$sb">
  Username (between 3 and 16 characters)<br>
  <input type=text name = Username value="$Username">
  <br><br>
  Password (between 4 and 10 characters)<br>
  <input type=password name = Password value="$Password">
  <br><br>
  Subject<br>
  <input type=text name = Subject>
  <br><br>
  Post<br>
  <textarea cols=80 rows=5 wrap=soft name="Body"></textarea>
  <br><br>
  <input type=submit value = "Submit Post">
  <input type=reset value = "Clear Form">
  </form>

  ~;

# Send a footer
  $sth -> finish;
  wwwthreads::send_footer;
