#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);

  use DBI;
  use strict;


# Get the input
  my %FORM = wwwthreads::get_input();


# Grab the cookie
  my %cookie = wwwthreads::get_cookie();


# Assign the variables
  my $Username = $cookie{'Username'};
  my $Password = $cookie{'Password'};
  my $Board = $FORM{'Board'};
  my $Number = $FORM{'Number'};
  my $page = $FORM{'page'};
  my $view = $FORM{'view'};
  my $what = $FORM{'what'};
  my $mode = $FORM{'mode'};
  my $sb = $FORM{'sb'};


# Connect to the database 
  wwwthreads::db_connect();
  my $query = '';

# Get the post info
  $query = qq!
    SELECT Main,Subject,Body
    FROM $Board
    WHERE Number = $Number
  !;

  my $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# Assign the stuff
  my ($Main,$Subject,$Body) = $sth ->fetchrow_array;


# Make sure we only put one Re: in front of the subject
  if (!($Subject =~/Re:/)){

    $Subject = "Re: ".$Subject;

  }


# Convert "'s to &quot;
  $Subject =~s /"/&quot;/g;
  $Body =~s /"/&quot;/g;


# Get the board info
  my $Board_q = $dbh -> quote($Board);
  $query = qq!
    SELECT HTML,Anonymous,Locked
    FROM Boards
    WHERE Keyword = $Board_q
  !;

  $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# Assign the stuff  
  my ($HTML,$Anonymous,$Locked) = $sth -> fetchrow_array;


# Send the header
  wwwthreads::send_header("Make a reply");

  wwwthreads::table_header("Make a reply");


  print "Fill out the form below to post a reply on the board.";


  if($HTML eq "Off"){

  # HTML is disabled, so we better let them know
    print " HTML is disabled for this board so you may not use HTML in your posts.";

  } else {

  # HTML is enabled, so let them know
    print " HTML is enabled for this board so you may use HTML in your posts.";

  }


  if($Anonymous eq "On"){

  # Anonymous is enabled, so let them know
    print" Anonymous postings are allowed, so if you do not have a Username just put Anonymous in the Username field and leave the password blank.";

  } else {

  # Anonymous is disabled, so let them know
    print" Anonymous postings are not allowed, so you will need to register a Username before you can post.";

  }
  
 
  if($Locked ne "Open"){

  # The board is locked, so let them know
    print" This board is read only, so you must be an administrator to post on it.";

  }

  print qq~
  </p><p>
  <form method= POST action = "$wwwthreads::config{'cgiurl'}/previewpost.pl">
  <input type=hidden name=Board value="$Board">
  <input type=hidden name=Main value="$Main">
  <input type=hidden name=Parent value="$Number">
  <input type=hidden name=page value="$page">
  <input type=hidden name=view value="$view">
  <input type=hidden name=what value="$what">
  <input type=hidden name=oldnumber value="$Number">
  <input type=hidden name=mode value="$mode">
  <input type=hidden name=sb value="$sb">
  Username (between 3 and 16 characters)<br>
  <input type=text name = Username value="$Username">
  <br><br>
  Password (between 4 and 10 characters)<br>
  <input type=password name = Password value="$Password">
  <br><br>
  Subject<br>
  <input type=text name = Subject value="$Subject">
  <br><br>
  Post<br>
  <textarea cols=80 rows=5 wrap=soft name="Body"></textarea>
  <br><br>
  <input type=submit value = "Submit Post">
  <input type=reset value = "Clear Form">
  </form>
  ~;

  wwwthreads::table_header("In response to:");

  print "$Body";


# Send the footer
  $sth -> finish;
  wwwthreads::send_footer();
