#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);

  use DBI;
  use strict;


# Get the form input
  my %FORM = wwwthreads::get_input();


# Assign the variables
  my $Username = $FORM{'Username'}; 
  my $Subject = $FORM{'Subject'};
  my $Body = $FORM{'Body'};
  my $Board = $FORM{'Board'};
  my $what = $FORM{'what'};
  my $page = $FORM{'page'};
  my $view = $FORM{'view'};
  my $Number = $FORM{'Number'};
  my $mode = $FORM{'mode'};
  my $option = $FORM{'option'};
  my $sb = $FORM{'sb'};


# Convert " to &quot;
  $Body =~s /"/&quot;/g;
  $Subject =~s /"/&quot;/g;


# IF we are changing this post do this block
  if ($option eq "Change this post") {


  # Connect to the database
    wwwthreads::db_connect();


  # Grab the board information
    my $Board_q = $dbh -> quote($Board);
    my $query = qq!
      SELECT HTML
      FROM Boards
      WHERE Keyword = $Board_q
    !;
    my $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";

    my ($HTML) = $sth -> fetchrow_array;


  # If HTML is off then we need to get rid of < and >
    if($HTML eq "Off") {

      $Subject =~s /</&lt;/g;
      $Body =~s />/&gt;/g;

    }


  # Now we send them their page
    wwwthreads::send_header("Preview your Modifications");

    wwwthreads::table_header("Preview your Modifications");

    print qq~ 

    The following is a preview of your modification.  If everything looks ok then you can click 'Continue' and your post will be entered.  If not then use your back button to go back and edit some more. 
    <p>
    <form method=POST action="$wwwthreads::config{'cgiurl'}/modifypost.pl">
    <input type=hidden name=Board value="$Board">
    <input type=hidden name=what value="$what">
    <input type=hidden name=page value="$page">
    <input type=hidden name=view value="$view">
    <input type=hidden name=Number value="$Number">
    <input type=hidden name=mode value="$mode">
    <input type=hidden name=sb value="$sb">
    <input type=hidden name=Subject value="$Subject">
    <input type=hidden name=Body value="$Body">
    Subject: $Subject
    <p>
    $Body
    <br><br>
    <input type=submit value="Continue">
    ~;

    $sth -> finish();
    wwwthreads::send_footer();


  } else {

# Otherwise we are deleting the post so do this sub

  # Send them their page 
    wwwthreads::send_header("Delete this post");
    wwwthreads::table_header("Delete this post");


    print qq~ 

    You have chosen to delete this post.  If you are sure you want to do this click the button below , otherwise use your back button to return to the last screen.
    <p>
    <form method=POST action="$wwwthreads::config{'cgiurl'}/deletepost.pl">
    <input type=hidden name=Username value="$Username">
    <input type=hidden name=Board value="$Board">
    <input type=hidden name=what value="$what">
    <input type=hidden name=page value="$page">
    <input type=hidden name=view value="$view">
    <input type=hidden name=Number value="$Number">
    <input type=hidden name=mode value="$mode">
    <input type=hidden name=sb value="$sb">
    <br><br>
    <input type=submit value="Yes, I want to delete this post">
    </form>
    ~;

  # Send the footer
    wwwthreads::send_footer();

}

