#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);
  use DBI;
  use strict;

# Get the form input
  my %FORM = wwwthreads::get_input;


# Assign the variables
  my $Username = $FORM{'Username'};
  my $Password = $FORM{'Password'};
  my $Subject = $FORM{'Subject'};
  my $Body = $FORM{'Body'};
  my $Board = $FORM{'Board'};
  my $Main = $FORM{'Main'};
  my $Parent = $FORM{'Parent'};
  my $what = $FORM{'what'};
  my $page = $FORM{'page'};
  my $view = $FORM{'view'};
  my $oldnumber = $FORM{'oldnumber'};
  my $mode = $FORM{'mode'};
  my $sb = $FORM{'sb'};


# Grab the IP address
  my $IP = $ENV{'REMOTE_ADDR'};


# Make sure all fields are filled in
  if((!$Username) || (!$Subject) || (!$Body)) {

    wwwthreads::not_right("All required fields are not filled in.");

  }


# Connect to the database
  wwwthreads::db_connect;
  my $query = '';
  my $sth   = '';

# Retrieve the info from the database
  my $Username_q = $dbh -> quote($Username);
  $query = qq!
    SELECT Password,Status
    FROM Users
    WHERE Username = $Username_q
  !;
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
  my $rows = $sth -> rows;
  my ($pass,$Status) = $sth -> fetchrow_array;


# If we did not find a match for the Username and they are not trying
# to post as Anonymous, let the user know
  if (($rows < 1) && ($Username ne "Anonymous")){

    wwwthreads::not_right("We could not find the Username '$Username' in our database.");

  }


# Make sure the given password matches the retrieved password except
# if they are trying to post as Anonymous
  if(($Password ne $pass) && ($Username ne "Anonymous")){

    wwwthreads::not_right("The password you gave does not match the password in our database for the Username '$Username'");

  }


# Grab the board information
  my $Board_q = $dbh -> quote($Board);
  $query = qq!
    SELECT HTML,Anonymous,Locked
    FROM Boards
    WHERE Keyword = $Board_q
  !;
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
  my ($HTML,$Anonymous,$Locked) = $sth -> fetchrow_array;


# If Anonymous is off and they are trying to post as anonymous tell them
# it doesn't work
  if (($Anonymous eq "Off") && ($Username eq "Anonymous")) {

    wwwthreads::not_right("Anonymous posts are not allowed on this board.");

  }


# If the board is locked and they are not an admin, let them know
  if(($Locked ne "Open") && ($Status ne "Administrator") && ($Status ne "Moderator") ) {

    wwwthreads::not_right("This board is read only.  Only Administrators and Moderators can post herre.");

  }


# If HTML is off then we need to get rid of < and >
  if($HTML eq "Off") {

    $Subject =~s /</&lt;/g;
    $Body =~s />/&gt;/g;

  }


# If not anonymous,Give them a cookie
  if ($Username ne "Anonymous") {

    wwwthreads::set_cookie('Username',"$Username",0,'Password',"$Password",0);

  }

  wwwthreads::send_header("Preview your post");
  wwwthreads::table_header("Preview your post");

  print qq~ 

  The following is a preview of your post.  If everything looks ok then you can click 'Continue' and your post will be entered.  If not then use your back button to go back and edit some more. 
  <p>
  <form method=POST action="$wwwthreads::config{'cgiurl'}/addpost.pl">
  <input type=hidden name=Board value="$Board">
  <input type=hidden name=Username value="$Username">
  <input type=hidden name=IP value="$IP">
  <input type=hidden name=what value="$what">
  <input type=hidden name=page value="$page">
  <input type=hidden name=view value="$view">
  <input type=hidden name=oldnumber value="$oldnumber">
  <input type=hidden name=mode value="$mode">
  <input type=hidden name=sb value="$sb">
  ~;


# Convert " to &quot; so it doesn't mess up the form
  $Body =~s /"/&quot;/g;
  $Subject =~s /"/&quot;/g;


  print qq~
  <input type=hidden name=Subject value="$Subject">
  <input type=hidden name=Body value="$Body">
  <input type=hidden name=Parent value="$Parent">
  <input type=hidden name=Main value="$Main">
  Subject: $Subject
  <p>
  $Body
  <br><br>
  <input type=submit value="Continue">
  ~;


  $sth -> finish;
  wwwthreads::send_footer;


