#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);

  use DBI;
  use strict;


# Get the form input
  my %FORM = wwwthreads::get_input();


# Assign the variables
  my $Sender    = $FORM{'Sender'};
  my $Username  = $FORM{'Username'};
  my $Subject   = $FORM{'Subject'};
  my $Message   = $FORM{'Message'};
  my $Board     = $FORM{'Board'};
  my $oldnumber = $FORM{'Number'};
  my $page      = $FORM{'page'};
  my $what      = $FORM{'what'};
  my $view      = $FORM{'view'};
  my $mode      = $FORM{'mode'};
  my $sb        = $FORM{'sb'};


# Connect to the database
  wwwthreads::db_connect();
  my $query = '';
  my $sth   = '';

# Check to see if the username is in our database
  my $Username_q = $dbh -> quote($Username);
  
  $query = qq!
    SELECT Username
    FROM Users
    WHERE Username = $Username_q
  !;

  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my $rows = $sth -> rows;

  if ($rows < 1){

  # We didn't find that Username, so let them know
    wwwthreads::not_right("We have no record of the Username '$Username' that you are trying to send this message to.");

  }


# Get the time
  my $date = wwwthreads::get_date();


# Get the next message number
  $query = qq!
    SELECT _seq FROM Messages
  !;
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my $Number = $sth -> fetchrow_array;


# Insert the message into the database marked as N - New
  $Username_q = $dbh -> quote($Username);
  my $Status_q   = $dbh -> quote("N");
  my $Subject_q  = $dbh -> quote($Subject);
  my $Sender_q   = $dbh -> quote($Sender);
  my $Message_q  = $dbh -> quote($Message);

  $query = qq!
    INSERT INTO Messages
    (Username,Read,Subject,Sender,Message,When,Number)
    VALUES ($Username_q, $Status_q, $Subject_q, $Sender_q, $Message_q, $date, $Number)
  !; 

  $sth = $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# Give them a sucess message and return them to the forum
   if($what eq "showpost") {

    wwwthreads::send_header("Your post has been entered","<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;url=$wwwthreads::config{'cgiurl'}/showpost.pl?Board=$Board&Number=$oldnumber&page=$page&view=$view&mode=$mode&sb=$sb\">");

  } else {

    wwwthreads::send_header("Your post has been entered","<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;url=$wwwthreads::config{'cgiurl'}/wwwthreads.pl?action=list&Board=$Board&page=$page&view=$view&sb=$sb\">");

  }

  wwwthreads::table_header("Your message has been sent");

  print"Your message has been sent.  You will now be returned to the forum.";


# Send the footer
  wwwthreads::send_footer();


