#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################

  use wwwthreads qw(%config $dbh);
  use DBI;
  use strict;


# Get the form input
  my %FORM = wwwthreads::get_input;


# Assign the variables
  my $Board = $FORM{'Board'};
  my $Number = $FORM{'Number'};
  my $page = $FORM{'page'};
  my $view = $FORM{'view'};
  my $row = $FORM{'row'};
  my $mode = $FORM{'mode'};
  my $sb = $FORM{'sb'};
  my $original = '';
  my $count = '';

# Grab the cookie to mark the posts as read or unread
  my %cookie = wwwthreads::get_cookie;
  my $b_id = "$Board.temp";
  my $unread = $cookie{$b_id};


# If mode is not set, then mode = $postlist
  if ( (!$mode) && ($cookie{'Display'}) ) { 
    $mode = $cookie{'Display'};
  } elsif ( (!$mode) && (!$cookie{'Display'}) ) {
    $mode = $wwwthreads::config{'postlist'};
  } 


# Connect to the database
  wwwthreads::db_connect;

  my $Board_q = $dbh -> quote($Board);

# Check if this board is locked and grab the Moderator
  my $query = qq!
    SELECT Locked,Moderator
    FROM Boards
    WHERE Keyword = $Board_q
  !; 
  my $sth = $dbh -> prepare($query) or die "Query Syntax Error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


  my ($locked,$moderator) = $sth -> fetchrow_array;


# Grab the main post number for this thread 
  $query = qq!
    SELECT Main
    FROM $Board
    WHERE Number=$Number
  !;
  $sth = $dbh -> prepare ($query) or die "Query Syntax Error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


  my ($current) = $sth -> fetchrow_array;


# Give them a cookie marking this message as read appending it to the others
  %cookie = wwwthreads::get_cookie;
  my $bname = "$Board.read";
  my $read = $cookie{$bname};
  my $check = ",$Number,";
  if(!($read =~/$check/)) {

    $read = $read.",$Number,";
    wwwthreads::set_cookie($bname,"$read",0);

  }


# Check if there are any replies in this thread
  $query = qq!
    SELECT Number
    FROM $Board
    WHERE Main=$current
  !;
  $sth = $dbh -> prepare ($query) or die "Query Syntax Error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
  my $checkreplies = $sth -> rows;


# Lets give the start of the page 
  wwwthreads::send_header("$wwwthreads::config{'title'}");

  print"<table border=0 width=100% cellspacing=0>";
  print"<tr><td colspan=2 bgcolor=$wwwthreads::config{'tdlight'}><p align=right>";


# Assign the sorder  
  my %sort_opt =  (
    1 => 'Subject DESC',
    2 => 'Subject ASC',
    3 => 'Username DESC',
    4 => 'Username ASC',
    5 => 'Posted DESC',
    6 => 'Posted ASC'
  );
  exists $sort_opt{$sb} ?
    (my $sort_by = $sort_opt{$sb}) :
    (my $sort_by = $sort_opt{1});
 
  if(!$sort_by) {$sort_by = "Posted DESC";}

# Grab all the main posts from the database
  $query = qq!
    SELECT Number,Main,Username,Subject,Posted
    FROM $Board
    WHERE Number = Main
    ORDER BY $sort_by
  !;
  
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
  my $total = $sth -> rows;
  my $newpage = 0;


# Cycle through all the posts to see if there are previous and next
# threads
  my ( $PNumber,$OldNumber,$Main,$OldMain,$Username,$OldUsername,$Subject,$OldSubject,$Posted,$OldPosted);
  for(my $i=0;$i<$total;$i++){

    $OldNumber = $PNumber;
    $OldMain = $Main;
    $OldUsername = $Username;
    $OldSubject = $Subject;
    $OldPosted = $Posted;
    ($PNumber,$Main,$Username,$Subject,$Posted) = $sth -> fetchrow_array;


  # If this isn't the first thread then we need to give them a link to
  # the previous thread otherwise they just get a greyed out image
    if( ($PNumber eq $current) && ($i > 0) ) {

      print "<a href=\"$wwwthreads::config{'cgiurl'}/showpost.pl?Board=$Board&Number=$OldNumber&page=$newpage&view=$view&sb=$sb\"><img src = \"$wwwthreads::config{'images'}/previous.gif\" alt = \"Previous Thread\" border=0></a>";
      my $previous = 1;

    } elsif ( ($i == 0) && ($PNumber eq $current) ) {

      print "<img src = \"$wwwthreads::config{'images'}/greyprevious.gif\">";

    }


  # Make sure we stay on the right page
    if($count >= ($wwwthreads::config{'postsperpage'} ) ) {
      $newpage++;
      $count = 0;
    }
    $count++;


  # If we are on the current thread then we give the link for all threads
    if($PNumber eq $current){

      print "<a href = \"$wwwthreads::config{'cgiurl'}/wwwthreads.pl?action=list&Board=$Board&page=$newpage&view=$view&sb=$sb\"><img src = \"$wwwthreads::config{'images'}/all.gif\" alt = \"View All Threads\" border=0></a>";


    # Now also grab the the next thread, and up the count so we are on the
    # proper page and exit the for loop
      if($count >= ($wwwthreads::config{'postsperpage'}) ) {
        $newpage ++;
        $count = 0;
      }

      ($PNumber,$Main,$Username,$Subject,$Posted) = $sth -> fetchrow_array;
    

    # If there is a next thread then give them a link to it otherwise they
    # get a greyed out image
      if($PNumber) {

        print "<a href=\"$wwwthreads::config{'cgiurl'}/showpost.pl?Board=$Board&Number=$PNumber&page=$newpage&view=$view&sb=$sb\"><img src = \"$wwwthreads::config{'images'}/next.gif\" alt = \"Next Thread\" border = 0></a>";

      } else {
    
        print "<img src=\"$wwwthreads::config{'images'}/greynext.gif\">";

      }


    # If we got here then we are listing the original thread starting post
    # so we set original to 1
      $original = 1;
      last;

    }

  }


# If $original was not set by the previous for loop then we are showing a
# reply, so just give a link back to the list of all threads
  if (!$original){

    print "<a href = \"$wwwthreads::config{'cgiurl'}/wwwthreads.pl?action=list&Board=$Board&page=$page&view=$view&sb=$sb\"><img src = \"$wwwthreads::config{'images'}/all.gif\" alt = \"View All Threads\" border=0></a>";

  }


# If $checkreplies = 1 and mode doesn't equal flat then we need to give them
# a link to show entire thread
  if (($checkreplies > 1) && ($mode ne "flat") && ($wwwthreads::config{'postlist'} ne "flat")){

    print "<a href=\"$wwwthreads::config{'cgiurl'}/showpost.pl?Board=$Board&Number=$Number&page=$page&view=$view&mode=flat&sb=$sb\"><img src=\"$wwwthreads::config{'images'}/flat.gif\" alt = \"Show in Flat Mode\" border=0></a>";
    print "<img src=\"$wwwthreads::config{'images'}/greythreaded.gif\">";


# Otherwise if $checkreplies < 2 and we are not doing flat mode then they
# dont get a flat or a threaded image.
  } elsif ( ($checkreplies < 2) && ($mode ne "flat") ) {

    print "<img src=\"$wwwthreads::config{'images'}/greyflat.gif\">";
    print "<img src=\"$wwwthreads::config{'images'}/greythreaded.gif\">";


# Otherwise they geta link to switch back to threaded
  } elsif ( ($checkreplies > 1) && ($mode eq "flat") && ($wwwthreads::config{'postlist'} ne "flat")){

    print "<img src=\"$wwwthreads::config{'images'}/greyflat.gif\">";
    print "<a href=\"$wwwthreads::config{'cgiurl'}/showpost.pl?Board=$Board&Number=$Number&page=$page&view=$view&mode=threaded&sb=$sb\"><img src=\"$wwwthreads::config{'images'}/threaded.gif\" alt = \"Show in Threaded Mode\" border=0></a>";

  }

  print"</td></tr>";
  print"</table>";


# If we are doing flat mode then show the entire post
  if( ($mode eq "flat") || ($wwwthreads::config{'postlist'} eq "flat") ){


  # Now cycle through all the posts
    $query = qq!
      SELECT Number,Posted,Username,IP,Subject,Body
      FROM $Board
      WHERE Main = $current
      ORDER BY Number
    !;
    $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    my $totalthread = $sth -> rows;

    for (my $i = 0;$i< $totalthread;$i++){

      my ($Number,$Posted,$Username,$IP,$Subject,$Body) = $sth -> fetchrow_array;
      my $time = wwwthreads::convert_time($Posted);

      my $EUsername = wwwthreads::url_encode($Username);

      print qq~ 
      <a name="Post$Number"></a>
      <table width=100% cellspacing=0 border=0>

      <tr><td width=20% bgcolor=$wwwthreads::config{'tddark'}>Subject</td><td bgcolor=$wwwthreads::config{'tddark'}>$Subject</td></tr>
      ~;

    # If its an anonymous post, dont' give a link to the profile
      if($Username eq "Anonymous") {

        print "<tr><td bgcolor=$wwwthreads::config{'tddark'}>Posted by</td><td bgcolor=$wwwthreads::config{'tddark'}>";
        print "Anonymous</td></tr>";

      } else {
    
        print "<tr><td bgcolor=$wwwthreads::config{'tddark'}>Posted by</td><td bgcolor=$wwwthreads::config{'tddark'}><a href=\"$wwwthreads::config{'cgiurl'}/showprofile.pl?User=$EUsername&Number=$Number&Board=$Board&what=showpost&page=$page&view=$view&mode=$mode&sb=$sb\">$Username</a></td></tr>";

      }

      print"<tr><td bgcolor=$wwwthreads::config{'tddark'}>Posted on</td><td bgcolor=$wwwthreads::config{'tddark'}>$time</td></tr>";

      if ($wwwthreads::config{'showip'}) {

        print "<tr><td bgcolor=$wwwthreads::config{'tddark'}>From IP</td><td bgcolor=$wwwthreads::config{'tddark'}>$IP</td></tr>";

      }

      print qq~ 
      <tr><td colspan=2 bgcolor=$wwwthreads::config{'tdlight'}>
      <br><br>$Body
      </td></tr>
      <tr><td colspan=2 bgcolor=$wwwthreads::config{'tddark'}>
      ~;

    # If the board is not locked then give them a reply button
      if ($locked eq "Open"){

        print qq~
        <br><a href=\"$wwwthreads::config{'cgiurl'}/newreply.pl?Board=$Board&Number=$Number&page=$page&view=$view&what=showpost&mode=$mode&sb=$sb\"><img src=\"$wwwthreads::config{'images'}/reply.gif\" alt = \"Reply to this message\" border=0></a>
        ~;

      } else {


      # If the board is locked then we need to see if they are an admin
      # or moderator to see if they get a reply button.
        my %cookie = wwwthreads::get_cookie;
        my $Username = $cookie{'Username'};
        if (!$Username) { $Username = " "; }
        my $Username_q = $dbh -> quote($Username);
        my $query =qq!
          SELECT Status
          FROM Users
          WHERE Username=$Username_q
        !;
        my $sti = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
        $sti -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
        my ($checkstat) = $sti -> fetchrow_array;
      
      # here we check for admin or moderator status
        if (($checkstat eq "Administrator") || ($checkstat eq "Moderator")) {

          print"<br><a href=\"$wwwthreads::config{'cgiurl'}/newreply.pl?Board=$Board&Number=$Number&page=$page&view=$view&what=showpost&mode=$mode&sb=$sb\"><img src=\"$wwwthreads::config{'images'}/reply.gif\" alt = \"Reply to this message\" border=0></a>";

        } else {

          print "<br><img src=\"$wwwthreads::config{'images'}/greyreply.gif\">";

        } 

      }


  # Now we check for a cookie
    my %cookie = wwwthreads::get_cookie;


  # If we found a cookie, lets see if they get a edit button
    if($cookie{'Username'}) {

    # we found a cookie.  If they own the post or they are a moderator give
    # them an edit button
      if( ($cookie{'Username'} eq $Username) || ($cookie{'Username'} eq "Moderator") ) {

        print "<a href=\"$wwwthreads::config{'cgiurl'}/editpost.pl?Board=$Board&Number=$Number&page=$page&view=$view&what=showpost&mode=$mode&sb=$sb\"><img src=\"$wwwthreads::config{'images'}/edit.gif\" border=0></a>";

    # otherwise the only way they get an edit button is if they are an admin
      } else {

        my $Username = $cookie{'Username'};
        if (!$Username) { $Username = " "; }
        my $Username_q = $dbh -> quote($Username);
        my $query = qq!
          SELECT Status
          FROM Users
          WHERE Username = $Username_q
        !;
        my $stj = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
        $stj -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
        my ($admin) = $stj -> fetchrow_array;
        if ($admin eq "Administrator") {

          print "<a href=\"$wwwthreads::config{'cgiurl'}/editpost.pl?Board=$Board&Number=$Number&page=$page&view=$view&what=showpost&mode=$mode&sb=$sb\"><img src=\"$wwwthreads::config{'images'}/edit.gif\" border=0></a>";

        }

      }

    }
    print "</td></tr></table>";


    print qq~ 
    <table border=0 width=100% bgcolor=$wwwthreads::config{'tdalt'}>
    <tr><td>
    </td></tr></table>
    ~;

  }


# we are doing threaded mode
  } else {

    my $query = qq!
      SELECT Number,Posted,Username,IP,Subject,Body,Parent
      FROM $Board
      WHERE Number=$Number
    !;
    $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

    my ($Number,$Posted,$Username,$IP,$Subject,$Body,$Parent) = $sth -> fetchrow_array;
    my $time = wwwthreads::convert_time($Posted);

    my $EUsername = wwwthreads::url_encode($Username);

    print qq~ 
    <a name="Post$Number"></a>
    <table width=100% cellspacing=0 border=0>

    <tr><td width=20% bgcolor=$wwwthreads::config{'tddark'}>Subject</td><td bgcolor=$wwwthreads::config{'tddark'}>$Subject</td></tr>
    ~;

  # If this is a reply post, then show what it is in reply to
    if ($Parent ne 0){

      my $query = qq!
        SELECT Subject
        FROM $Board
        WHERE Number=$Parent
      !;
      $sth = $dbh -> prepare ($query);
      $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
      my ($Subject) = $sth -> fetchrow_array;

      print"<tr><td bgcolor=$wwwthreads::config{'tddark'}>In Reply To</td><td bgcolor=$wwwthreads::config{'tddark'}><a href=\"$wwwthreads::config{'cgiurl'}/showpost.pl?Board=$Board&Number=$Parent&page=$page&view=$view&sb=$sb\">$Subject</a>";

    }

    if ($Username eq "Anonymous"){

      print "<tr><td bgcolor=$wwwthreads::config{'tddark'}>Posted by</td><td bgcolor=$wwwthreads::config{'tddark'}>";
      print "Anonymous</td></tr>";

    } else {

      print "<tr><td bgcolor=$wwwthreads::config{'tddark'}>Posted by</td><td bgcolor=$wwwthreads::config{'tddark'}><a href=\"$wwwthreads::config{'cgiurl'}/showprofile.pl?User=$EUsername&Number=$Number&Board=$Board&what=showpost&page=$page&view=$view&mode=$mode&sb=$sb\">$Username</a></td></tr>";

    }

    print"<tr><td bgcolor=$wwwthreads::config{'tddark'}>Posted on</td><td bgcolor=$wwwthreads::config{'tddark'}>$time</td></tr>";

    if ($wwwthreads::config{'showip'}) {

      print "<tr><td bgcolor=$wwwthreads::config{'tddark'}>From IP</td><td bgcolor=$wwwthreads::config{'tddark'}>$IP</td></tr>";

    }

    print qq~ 
    <tr><td colspan=2 bgcolor=$wwwthreads::config{'tdlight'}>
    <br><br>$Body
    </td></tr>
    <tr><td colspan=2 bgcolor=$wwwthreads::config{'tddark'}>
    ~;

  # If the board is open, give them a reply button
    if($locked eq "Open"){

      print qq~
      <br><a href="$wwwthreads::config{'cgiurl'}/newreply.pl?Board=$Board&Number=$Number&page=$page&view=$view&what=showpost&mode=$mode&sb=$sb"><img src="$wwwthreads::config{'images'}/reply.gif" alt = "Reply to this message" border=0></a>
      ~;

    }else {


    # If the board is locked then we need to see if they are an admin
    # or moderator to see if they get a reply button.
      my %cookie = wwwthreads::get_cookie;
      my $Username = $cookie{'Username'};
      if(!$Username) { $Username = " "; }
      my $Username_q = $dbh -> quote($Username);
      my $query = qq!
        SELECT Status
        FROM Users
        WHERE Username = $Username_q
      !;
      $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Quer: $query";
      $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
      my ($checkstat) = $sth -> fetchrow_array;
    

    # Check if they are a moderator or an admin
      if (($checkstat eq "Administrator") || ($checkstat eq "Moderator")) {

        print"<br><a href=\"$wwwthreads::config{'cgiurl'}/newreply.pl?Board=$Board&Number=$Number&page=$page&view=$view&what=showpost&mode=$mode&sb=$sb\"><img src=\"$wwwthreads::config{'images'}/reply.gif\" alt = \"Reply to this message\" border=0></a>";

      } else {

        print "<br><img src=\"$wwwthreads::config{'images'}/greyreply.gif\">";

      }

    }


  # Now we check for a cookie
    %cookie = wwwthreads::get_cookie;


  # If we found a cookie, lets see if they get a edit button
    if($cookie{'Username'}) {

      if( ($cookie{'Username'} eq $Username) || ($cookie{'Username'} eq "Moderator") ) {
 
        print "<a href=\"$wwwthreads::config{'cgiurl'}/editpost.pl?Board=$Board&Number=$Number&page=$page&view=$view&what=showpost&mode=$mode&sb=$sb\"><img src=\"$wwwthreads::config{'images'}/edit.gif\" border=0></a>";

      } else {

        my $Username = $cookie{'Username'};
        if (!$Username) { $Username = " "; }
        my $Username_q = $dbh -> quote($Username);
        my $query =qq!
          SELECT Status
          FROM Users
          WHERE Username = $Username_q
        !;
        $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
        $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
        my ($admin) = $sth -> fetchrow_array;
        if ($admin eq "Administrator") {

          print "<a href=\"$wwwthreads::config{'cgiurl'}/editpost.pl?Board=$Board&Number=$Number&page=$page&view=$view&what=showpost&mode=$mode&sb=$sb\"><img src=\"$wwwthreads::config{'images'}/edit.gif\" border=0></a>";

        }

      }

    }

    print "</td></tr> </table>";


  # Lets see if there are any replies to this message
    $query = qq!
      SELECT Parent
      FROM $Board
      WHERE Parent = $Number
    !;
    $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    my $checkreplies = $sth -> rows;

    if($checkreplies > 0) {

      print qq~ 
      <table border=0 width=100% bgcolor=$wwwthreads::config{'tdalt'}>
      <tr><td></td></tr>
      </table>

      <TABLE BORDER=0 WIDTH=100% cellspacing=0>
      <tr><td align=center colspan=3 bgcolor=$wwwthreads::config{'tddark'}><b>Replies to this message</b></center></td></tr>
      <tr><td width=55% bgcolor=$wwwthreads::config{'tddark'}>Subject</td><td bgcolor=$wwwthreads::config{'tddark'} width=20%>Posted by</td><td bgcolor=$wwwthreads::config{'tddark'}>Posted On</td></tr>

      ~;

      my $color = $wwwthreads::config{'tdlight'};
      my $indent = 0;
      $color = &show_replies($Board,$Number,$page,$view,$sb,$indent,$color,$unread);
      print "</table>";
    }

  }

  $sth -> finish;
# Send the footer
  wwwthreads::send_footer;


#######################################################################
# Show replies
#######################################################################

  sub show_replies {

    my ($Board,$Number,$page,$view,$sb,$indent,$color,$unread) = @_;

    my $rname  = "$Board.read";
    my %cookie = wwwthreads::get_cookie();
    my $read   = $cookie{$rname};

  # Heres where we actually list the replies
    my $query =qq!
      SELECT Number,Parent,Posted,Username,Subject
      FROM $Board
      WHERE Parent = $Number
      ORDER BY Number DESC
    !;

    my $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    my $followups = $sth -> rows;

    $indent++;

    for(my $x=0;$x<$followups;$x++){

      my ($PNumber,$Parent,$Posted,$Username,$Subject) = $sth -> fetchrow_array;

      print "<tr><td bgcolor=$color>";
      for (my $y=0;$y<$indent;$y++){

        print "<img src=\"$wwwthreads::config{'images'}/blank.gif\">";

      }

      my $time = wwwthreads::convert_time($Posted);
      my $folder = "closedfolder.gif";
      my $thisone = ",$PNumber,";

      if( ($Posted > $unread) && (!($read =~/$thisone/)) ){

        $folder = "newclosedfolder.gif";

      } 
      else {

        $folder = "closedfolder.gif";

      }
 
      print"<a href=\"$wwwthreads::config{'cgiurl'}/showpost.pl?Board=$Board&Number=$PNumber&page=$page&view=$view&sb=$sb#Post$PNumber\"><img src=\"$wwwthreads::config{'images'}/$folder\" alt=\"*\" border=0 hspace=5>$Subject</a>";

      if ($Username eq "Anonymous") {
        print"</td><td width=20% bgcolor=$color>Anonymous</td>";
      }else{
        my $EUsername = wwwthreads::url_encode($Username);
        print"</td><td width=20% bgcolor=$color><a href=\"$wwwthreads::config{'cgiurl'}/showprofile.pl?User=$EUsername&Number=$Number&Board=$Board&what=showpost&page=$page&view=$view&mode=$mode&sb=$sb\">$Username</a></td>";
      }

      print "<td bgcolor=$color>$time</td></tr>";

    # alternate the colors
      if ($color eq "$wwwthreads::config{'tdlight'}") {
        $color = "$wwwthreads::config{'tddark'}";
      } else {
        $color = "$wwwthreads::config{'tdlight'}";
      }

      my $query = qq!
        SELECT Number
        FROM $Board
        WHERE Parent = $PNumber
      !;
      my $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
      $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
      my $follows = $sth -> rows;
      if ($follows > 0) {

        $color = &show_replies($Board,$PNumber,$page,$view,$sb,$indent,$color,$unread);

      }

    }

    $indent--;
    $sth -> finish;
    return $color;
  }
